/**
 * This file is part of:
 *    star-ips -- a family of incremental GMRF estimation algorithms.
 *
 * Authors:
 *   Cyril Furtlehner, cyril.furtlehner@inria.fr
 *   Victorin Martin, victorin.martin@gmail.com
 *   Jean-Marc Lasgouttes, jean-marc.lasgouttes@inria.fr
 *
 * This software is distributed under the Creative Commons License
 * BY-NC-SA. The complete license can be found here
 *   http://creativecommons.org/licenses/by-nc-sa/4.0/legalcode
 */

#ifndef GMRF_H
#define GMRF_H

#include "Tools.h"

class GMRF
{

public:
	GMRF (gsl_matrix *);

	//Class members
	int Nn, Na, Nc;
	double Km;
	vector2 < int >Vois, ind;
	std::vector < int >nv, na, nv0, indexes;
	vector2 < double >PrecisionMatrix;
	std::vector < double >hmu;

	int prune (double);
	int prune_from_Pmatrix (gsl_matrix *);
	int prune_all ();
	bool load_SpecificData ();
	void re_index (int, int, int);
	bool load_model ();
	bool build_neighborhood (int, int = 0);
	void set_XX_YY_Mask(int,int);
	void set_XY_Mask(int,int);
};

#endif //GMRF_H
