# star-ips – a family of incremental GMRF estimation algorithms.

See file NEWS for recent changes.

Authors:
 - Cyril Furtlehner, <cyril.furtlehner@inria.fr>
 - Victorin Martin, <victorin.martin@gmail.com>
 - Jean-Marc Lasgouttes, <jean-marc.lasgouttes@inria.fr>




About star-ips
--------------

star-ips is a free open-source program that implements of a family of
algorithms based on the Iterative Proportional Scaling (IPS)
procedure. Using IPS, it incrementally selects links and
partial correlations of a GMRF imposing spectral and-or topological
constraints. For more details about the star-ips framework see
[the star-ips page](https://who.rocq.inria.fr/Jean-Marc.Lasgouttes/star-ips/).


Building star-ips
-----------------

Here is what is needed to build star-ips:

- A C++ compiler that handles C++11. The Makefile assumes gcc.
- The libraries gsl and cblas.

To build star-ips just execute

    make

Note that it could be necessary to modify the Makefile to cope with
your particular system. It has been successfully tested under
various Ubuntu distributions.

star-ips has not been tested under Windows, but since it is written in
standard C++, it should work.


Using star-ips
--------------

A complete list of the parameters with their meaning is displayed
when executing

    ./star-ips -h

Just execute `./star-ips` with your parameters.
Mandatory parameters are the covariance matrix (given by a simple
text file) and the number of variables. Usage is

    ./star-ips -nv 1000 -cov_file cov.dat [-otherparam value]...

Parameters can alternatively be read from a configuration file using

    ./star-ips -config_file name.

Parameters given in command line have priority over the configuration
file. An example configuration file is given (`ex.config`).


Examples
--------

_[coming soon]_

Legal issues
------------

This software is distributed under the Creative Commons License
BY-NC-SA. The complete license can be found here:

  <http://creativecommons.org/licenses/by-nc-sa/4.0/legalcode>

Basically you're free to use, modify and distribute it as long as
you acknowledge us, use the same license and do not sell it.

star-ips is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.
